# Ein perl programm von Georg Edelmayer
# evag.pl soll eine (verbesserte) Zugvorlage aus dem computer Report erstellen.
#
# Eine Beschreibug aller Features gibt bei der subroutine metabefehle,
# als .html file beim Autor bzw. ber die Eressea-client liste.
# Bei Fragen, Wnschen, Anregungen mail to: ged@fortec.tuwien.ac.at
# 
# 
#
#	 Copyright (c) 1999/2000 Georg Edelmayer. All rights reserved.
#         This program is free software; you can redistribute it and/or
#           modify it under the same terms as Perl itself.
#
#    I AM NOT RESPOSIBLE FOR ANY PROBLEMS THAT
#         THIS MAY CAUSE WHATSOEVER. 
#
#
#---------------------------------------------------------------
# usage 
# perl evag.pl cr >zugvorlage
# 


use strict;
#use diagnostics;
#use Getopt::Std; 
#use Benchmark ;
#my $t0 = new Benchmark;
#print STDERR $t0;

my $VERSION = '0.34 fuer CR 38';
my $LASTREVISION = '23.3.2000';


#####################################################################
#------------------------------
# evag spezivische Definitionen
#------------------------------ 

my ($c ,$d,$CR_Version, $My_Partei_Nr, $Runde, $My_Options, $Punkte, $Punkteds, $My_Typ, $My_Pers_Zahl );
my ($Stat, $N, $P,$code,$x,$y, $temp, $key, $Line) ;
my ($r_id, $s_id,$b_id, $e_id);
use vars qw/%r %rgi %Parteien/;  
# %r der Report 
# %rgi report_general_info ...alles im 'header' der  reports
# %Parteien information zum allianzstatus

my $codes = "DURCHREISE|GEGENSTAENDE|REGION |REGIONSEREIGNISSE|REGIONSBOTSCHAFTEN|REGIONSKOMMENTAR|PREISE|UMGEBUNG|SCHIFF |BURG |EINHEIT |EINHEITSBOTSCHAFTEN|TALENTE|COMMANDS|SPRUECHE|
|ALLIANZ|KAEMPFE|EREIGNISSE|MELDUNGEN|EINKOMMEN|HANDEL|PRODUKTION|BEWEGUNGEN|PARTEI|TRAENKE|ZAUBER";  #alle codetokens  

my $Actual_Version = 38; # also version 37 sollte evag kennen

#======================= 
# Headerblabla 
#=======================

print STDERR "\n\n\n";
print STDERR '####              EVAG Eressea VorlAgen Generator         ####'."\n";
print STDERR '                 ein Perl Script von Georg Edelmayer     '."\n";
print STDERR '                       Version: '.$VERSION."\n";
print STDERR '                    Letze Aenderung: '. $LASTREVISION."\n\n";
print STDERR '  	 Copyright (c) 1999/2000 Georg Edelmayer. All rights reserved.'."\n";
print STDERR '  This program is free software; you can redistribute it and/or modify it'."\n";
print STDERR '                under the same terms as Perl itself'."\n\n";

#---------------------------------------------
# Los gehts mit einlesen
#---------------------------------------------

my $infile = pop(@ARGV);
open (INFILE, $infile) or die "Kann $infile nicht oeffnen";

#open (DEB, ">debug.txt") or die "Kann debug nicht oeffnen"; #nur fuer den fall, dass wir ein debugfile brauchen

$_ = <INFILE>;	
chomp;		# Version 
($c,$d) = split(/;/);
$c =~ /VERSION (\d+)/;
$CR_Version = $1;
print 'Version des Computerreports: '.$CR_Version."\n";
$rgi{'CRVERSION'}=$CR_Version;
if ($Actual_Version != $CR_Version){
  print 'ACHTUNG Versionsunterschied!'."\n";
  print ' CR-Version '.$CR_Version.' wird moeglicher Weise nicht richtig behandelt'."\n";
}
$key = 'VERSION';
while (!eof){
	$_ = <INFILE>;
	chomp;
	if 	($_ =~ /.*\;.*/){
		($c,$d) = split (/;/);
		$rgi{$key}{$d}=$c;	# dem rgi hash zuordnen
	}
	else{	
		$_ =~/^([A-Z]+)\s?(\d+)?/;
		$code = $1;
		if ($code eq 'PARTEI'){
			$key = 'PARTEI';
			$rgi{$key}{'Nummer'}= $2;
		}
		elsif ($code eq 'ALLIANZ'){
			last;
		}
		else{
			print 'unbekannter Code '.$1."\n";
			$code = 'unbekannt';
		}	
	}
}	

while (!eof){
  if ($code eq 'ALLIANZ'){
    print 'Al';
    &parse_allianz;
  }  
  if ($code eq 'KAEMPFE'){
    print 'Ka';
    &parse_kaempfe;
  }
  if ($code eq 'EREIGNISSE'){
    print 'Er';
    &parse_ereignisse;
  } 
  if ($code eq 'EINKOMMEN'){
    print 'Ei';
    &parse_einkommen;
  }	
  if ($code eq 'HANDEL'){
    print 'Ha';
    &parse_handel;
  }
  if ($code eq 'PRODUKTION'){
    print 'Pr';
    &parse_produktion;
  }
  if ($code eq 'BEWEGUNGEN'){
    print 'Be';
    &parse_bewegungen;
  } 
  if ($code eq 'PARTEI'){
    print 'Pa';
    &parse_partei;
  }
  if ($code eq 'ZAUBER'){
    print 'Za';
    &parse_zauber;
  }
  if ($code eq 'TRAENKE'){
    print 'Tr';
    &parse_traenke;
  }

  if ($code =~/(REGION ).*/){
    print '*';    
    &parse_region;
  }
  if ($code eq 'UMGEBUNG'){
    &parse_umgebung;
  }
  if ($code eq 'DURCHREISE'){
    print '*';  
    &parse_durchreise;
  }
  if ($code eq 'REGIONSBOTSCHAFTEN'){
    &parse_regionsbotschaften;
  }
  if ($code eq 'REGIONSEREIGNISSE'){
    &parse_regionsereignisse;
  }
  if ($code eq 'REGIONSKOMMENTAR'){
    &parse_regionskommentar;
  } 
  if ($code eq 'PREISE'){
    &parse_preise;
  }
  if ($code=~/(SCHIFF .*)/){
    &parse_schiff;
  }
  if ($code=~/(BURG .*)/){
    &parse_burg;
  }
  if ($code =~ /(EINHEIT .*)/){
    print '.';  
    &parse_einheit;
  }
  if ($code eq 'EINHEITSBOTSCHAFTEN'){
    &parse_einheitsbotschaften;
  }
  if ($code eq 'GEGENSTAENDE'){
    &parse_gegenstaende;
  }
  if ($code eq 'SPRUECHE'){
    &parse_sprueche;
  }
  if ($code eq 'TALENTE'){
    &parse_talente;
  }
  if ($code eq 'COMMANDS'){
    &parse_commands;
  }
  if ($code eq 'unbekannt'){		# behandlung nicht bekannter/implementierter CODES
    while (<INFILE>){				# Es wird so lange gelesen bis wieder ein CODE kommt
      chomp;						# danach wird geprueft ob er erkannt wurde
      if ($_ =~/^($codes.*)/){		# danach raus und die CODE checken
	$code=$1;
	last;
      }
      elsif ($_=~/(^[A-Z]+)/){
	print 'unbekannter Code '.$1."\n";
	$code = 'unbekannt';
	last;
      }
      else{
		1;
      }
    }
  }
}
print 'ENDE';


##########################################

sub parse_region{
  $_ =~ /^REGION (-?\d+ -?\d+)/;
  $r_id = $1;
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      ($c,$d)=split(/;/);
      $r{$r_id}{$d}=$c;
    }
  }
}
######################################
sub parse_umgebung{
  while (<INFILE>){
    chomp;
   if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      push @{$r{$r_id}{'UMGEBUNG'}}, $_;
    }
  }
}
######################################
sub parse_durchreise{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      push @{$r{$r_id}{'DURCHREISE'}}, $_;
    }
  }
}
###########################################

sub parse_regionsbotschaften{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      push @{$r{$r_id}{'REGIONSBOTSCHAFTEN'}}, $_;
    }
  }
}
#############################################
sub parse_regionsereignisse{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      push @{$r{$r_id}{'REGIONSEREIGNISSE'}}, $_;
    }
  }
}
#############################################
sub parse_regionskommentar{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      push @{$r{$r_id}{'REGIONSKOMMENTAR'}}, $_;
    }
  }
}


#############################################
sub parse_preise{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      ($c,$d) = split(/;/); 
      push @{$r{$r_id}{'PREISE'}}, $c;	#wir geben nur die Preise drauf, die Reihenfolge ist alphabetisch, daher aendert sie sich nicht
    }
  }
}

#############################################
sub parse_schiff{
  $_ =~/^SCHIFF (.*)/;
  $s_id = $1;
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      ($c,$d)=split(/;/);
      $r{$r_id}{'SCHIFF'}{$s_id}{$d}=$c;    
    } 
  }
}
###################################
sub parse_burg{
  $_ =~ /^BURG (.*)/;
  $b_id = $1;
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      ($c,$d)=split(/;/);
      $r{$r_id}{'BURG'}{$b_id}{$d}=$c;
    }
  }
}
###################################
sub parse_einheit{
  $_ =~/^EINHEIT (.*)/;
  $e_id =&base2base($1);
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      ($c,$d)=split(/;/);
      $r{$r_id}{'EH'}{$e_id}{$d}=$c;    
    } 
  }
}
######################

sub parse_einheitsbotschaften{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      push @{$r{$r_id}{'EH'}{'EINHEITSBOTSCHAFTEN'}}, $_;
    }
  }
}
########################################
sub parse_gegenstaende{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
     ($c,$d)=split(/;/);
     $r{$r_id}{'EH'}{$e_id}{'GEGENSTAENDE'}{$d}=$c;
    }
  }
}
######################
sub parse_sprueche{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
     push @{$r{$r_id}{'EH'}{$e_id}{'SPRUECHE'}}, $_;
    }
  }
}
######################
sub parse_talente{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      ($c,$d)=split(/;/);
      $r{$r_id}{'EH'}{$e_id}{'TALENTE'}{$d}=$c;    
    } 
  }
}
######################

sub parse_commands{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      push @{$r{$r_id}{'EH'}{$e_id}{'COMMANDS'}}, $_;    
    } 
  }
}
######################
sub base2base {		# baseconverter von base10 nach base32 fuer die Einheiten-Nummern
my ($mult, $mult1, $i, $base32x);
my  $base10 = shift;
my  $base32 ='';
my  %base = (
	   0 => '0',
	   1 => '1',
	   2 => '2',
	   3 => '3',
	   4 => '4',
	   5 => '5',
	   6 => '6',
	   7 => '7',
	   8 => '8',
	   9 => '9',
	   10 => 'a',
	   11 => 'b',
	   12 => 'c',
	   13 => 'd',
	   14 => 'e',
	   15 => 'f',
	   16 => 'g',
	   17 => 'h',
	   18 => 'i',
	   19 => 'j',
	   20 => 'k',
	   21 => 'l',
	   22 => 'm',
	   23 => 'n',
	   24 => 'o',
	   25 => 'p',
	   26 => 'q',
	   27 => 'r',
	   28 => 's',
	   29 => 't',
	   30 => 'u',
	   31 => 'v',
	   32 => 'w',
	   33 => 'x',
	   34 => 'y',
	   35 => 'z',
	  );
  foreach $i (3,2,1,0){
    $mult = $base10/(36**$i);
    $mult1 =int($mult);
	$base32x = $base{$mult1};
	$base10 = $base10-$mult1*(36**$i);
	$base32 .= $base32x;
  }
$base32 =~ s/^0+//;	# Fuehrende Nullen weg
$base32 =~ s/l/L/;	# kleine l zu Grossen wegen Lesbarkeit
return $base32;
}
#####################################################
sub helfestatus {    # liefert einen String der Helfestatii
use integer;
my $Stat = shift;

my @exp = (1,2,4,8,16);
my $i;
my $Statusstring = '';
my %st = (
	  1 => 'SILBER',
	  2 => 'KAEMPFE',   
	  4 => 'Nicht benutzt',
	  8 => 'GIB',
	  16 => 'BEWACHE',  
	  );

foreach $i (@exp){
  if ($Stat & $i){
    $Statusstring .= $st{$i}.' ';   # Den Statusstring zusammenstellen
  }
}   
if ($Stat & (1+2+8+16)){
  $Statusstring = 'ALLES';
}

return $Statusstring;
no integer
}
#####################################################
sub optionen {    # liefert einen String der Optionen
#use integer;
my $Opt = shift;

my @exp = (1,2,4,8,16,32,64,128,256,512);
my $i;
my $Optionsstring = '';
my %opt = (
	  1 => 'Auswertung',
	  2 => 'Computer',   
	  4 => 'Zugvorlage',
	  8 => 'Silberpool',
	  16 => 'Statistik', 
	  32 => 'not used', 
	  64 => 'Zipped', 
	  128 => 'Merian', 
	  256 => 'Materialpool',  
	  512 => 'Adressen', 
	  );

foreach $i (@exp){
  if ($Opt & $i){
    $Optionsstring .= $opt{$i}.' ';   # Den Optionsstring zusammenstellen
  }
}   

return $Optionsstring;
#no integer
}

#####################################################
sub remgoose{     # entfernt Anfuehrungszeichen 
  my $line = shift;
  $line =~ s/^\"//;		#am anfang weg
  $line =~ s/\"$//;		# am ende weg
  return $line;
}


######################################################
sub parse_allianz{
  my ($N, $Stat, $temp, $Name);
  $_=~/ALLIANZ\s(\d+)/;
  $N =$1;
  $temp = <INFILE>;             # der Parteinummer
  $Name = &remgoose($temp);  # Parteiname
  $_ = <INFILE>;
  ($Stat , $temp) = split (/;/); # der Helfestatus
  $Parteien{$N}{'NAME'}=$Name;
  ${Parteien{$N}{'STATUS'}} = &helfestatus($Stat) ;
  $_ = <INFILE>;
  chomp;
  if ($_=~/^($codes.*)/){ 
    $code=$1;
    return;
  }
  elsif ($_=~/(^[A-Z]+)/){
    print 'unbekannter Code '.$1."\n";
    $code = 'unbekannt';      
    return;
  }
}
##########################################################
sub parse_ereignisse{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      if ( $_ =~ /^\"!.*/){      # Wenn Arg
	push @{$rgi{'EREIGNISSE'}{'ARG'}} , substr &remgoose($_),1 ;# Anfuehrungszeichen weg und erstes Zeichen weg
      }
      elsif ( $_ =~ /^\"F.*/){      # Wenn Fehler
	push @{$rgi{'EREIGNISSE'}{'FEHLER'}} , substr &remgoose($_),1; 
	    }
      elsif ( $_ =~ /^\"W.*/){      # Wenn  Meldung
	push @{$rgi{'EREIGNISSE'}{'WARN'}} , substr &remgoose($_),1 ; 
      }
      elsif ( $_ =~ /^\"I.*/){      # Wenn  Meldung
	push @{$rgi{'EREIGNISSE'}{'INFO'}} , substr &remgoose($_),1; 
      }
      else{
	print 'unbekannte Zeile '.$_."\n";
      }
    }
  }
}

###############################################################
sub parse_kaempfe{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      if ( $_ =~ /^\"I.*/){      # Wenn Arg
	push @{$rgi{'KAEMPFE'}{'INFO'}} , substr &remgoose($_),1 ;
      }
      else{
	print 'unbekannte Zeile '.$_."\n";
      }
    }
  }
}
###########################################################
sub parse_einkommen{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      if ( $_ =~ /^\"W.*/){     
	push @{$rgi{'EINKOMMEN'}{'WARN'}} , substr &remgoose($_),1 ; 
      }
      elsif ( $_ =~ /^\"F.*/){      # Wenn Fehler
	push @{$rgi{'EINKOMMEN'}{'FEHLER'}} , substr &remgoose($_),1; 
	    }
      elsif ( $_ =~ /^\"I.*/){      
	push @{$rgi{'EINKOMMEN'}{'INFO'}} , substr &remgoose($_),1; 
      }
      else{
	print 'unbekannte Zeile '.$_."\n";
      }
    }
  }
}
#############################################################
sub parse_handel{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      if ( $_ =~ /^\"!.*/){      # Wenn Arg
	push @{$rgi{'HANDEL'}{'ARG'}} , substr &remgoose($_),1 ;# Anfuehrungszeichen weg und erstes Zeichen weg
      }
      elsif ( $_ =~ /^\"F.*/){      # Wenn Fehler
	push @{$rgi{'HANDEL'}{'FEHLER'}} , substr &remgoose($_),1; 
	    }
      elsif ( $_ =~ /^\"W.*/){      # Wenn  Meldung
	push @{$rgi{'HANDEL'}{'WARN'}} , substr &remgoose($_),1 ; 
      }
      elsif ( $_ =~ /^\"I.*/){      # Wenn  Meldung
	push @{$rgi{'HANDEL'}{'INFO'}} , substr &remgoose($_),1; 
      }
      else{
	print 'unbekannte Zeile '.$_."\n";
      }
    }
  }
}
#############################################################
sub parse_produktion{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      if ( $_ =~ /^\"!.*/){      # Wenn Arg
	push @{$rgi{'PRODUKTION'}{'ARG'}} , substr &remgoose($_),1 ;# Anfuehrungszeichen weg und erstes Zeichen weg
      }
      elsif ( $_ =~ /^\"F.*/){      # Wenn Fehler
	push @{$rgi{'PRODUKTION'}{'FEHLER'}} , substr &remgoose($_),1; 
	    }
      elsif ( $_ =~ /^\"W.*/){      # Wenn  Meldung
	push @{$rgi{'PRODUKTION'}{'WARN'}} , substr &remgoose($_),1 ; 
      }
      elsif ( $_ =~ /^\"I.*/){      # Wenn  Meldung
	push @{$rgi{'PRODUKTION'}{'INFO'}} , substr &remgoose($_),1; 
      }
      else{
	print 'unbekannte Zeile '.$_."\n";
      }
    }
  }
}
###############################################
sub parse_bewegungen{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      if ( $_ =~ /^\"F.*/){      # Wenn Fehler
	push @{$rgi{'BEWEGUNGEN'}{'FEHLER'}} , substr &remgoose($_),1; 
	    }
      elsif ( $_ =~ /^\"W.*/){      # Wenn  Meldung
	push @{$rgi{'BEWEGUNGEN'}{'WARN'}} , substr &remgoose($_),1 ; 
      }
      elsif ( $_ =~ /^\"I.*/){      # Wenn  Meldung
	push @{$rgi{'BEWEGUNGEN'}{'INFO'}} , substr &remgoose($_),1; 
      }
      else{
	print 'unbekannte Zeile '.$_."\n";
      }
    }
  }
}
#########################################
sub parse_partei{
my ($nr, $d, $PName, $Email, $Banner);
$_ =~ /PARTEI\s(\d+)/;
$nr = $1;
$_ = <INFILE>;
($PName,$d) = split(/;/);
$rgi{'PARTEI'}{$nr}{'NAME'}=$PName;
$_ = <INFILE>;
($Email,$d) = split(/;/);
$rgi{'PARTEI'}{$nr}{'EMAIL'}=$Email;
$_ = <INFILE>;
($Banner,$d) = split(/;/);
$rgi{'PARTEI'}{$nr}{'BANNER'}=$Banner;
$_ = <INFILE>;
chomp;
if ($_=~/^($codes.*)/){
  $code=$1;
  return;
}
elsif ($_=~/(^[A-Z]+)/){
  print 'unbekannter Code '.$1."\n";
  $code = 'unbekannt';      
  return;
}
}

########################################################
sub parse_zauber{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      if ( $_ =~ /^\"I.*/){      # Wenn  Meldung
	push @{$rgi{'ZAUBER'}{'INFO'}} , substr &remgoose($_),1; 
      }
      else{
	print 'unbekannte Zeile '.$_."\n";
      }
    }
  }
}
######################################################
sub parse_traenke{
  while (<INFILE>){
    chomp;
    if ($_=~/^($codes.*)/){
      $code=$1;
      return;
    }
    elsif ($_=~/(^[A-Z]+)/){
      print 'unbekannter Code '.$1."\n";
      $code = 'unbekannt';      
      return;
    }
    else{
      if ( $_ =~ /^\"I.*/){      # Wenn  Meldung
	push @{$rgi{'TRAENKE'}{'INFO'}} , substr &remgoose($_),1; 
      }
      else{
	print 'unbekannte Zeile '.$_."\n";
      }
    }
  }
}
__END__
  

 
